#!/bin/ksh

#####################################################
# Run the sql query against the selected database   #
# The only modification needed for this procedure   #
# is the sql command itself. This is written in     #
# standard INFORMIX SQL                             #
#####################################################

. $1 
export DBMONEY=.

run_sql()
{
STAT=`onstat - | head -2 | tail -1 | cut -d'-' -f3`

if [ $STAT = 'On' ] 
	then XX="Online"
elif [ $STAT = 'Single' ] 
	then XX="Single"
elif [ $STAT = 'Quiescent' ] 
	then XX="Quiescent"
else XX="Off"
fi

#echo $XX


#MSG="$INFORMIXSERVER"'     '"$XX"
#echo "$MSG" >/tmp/ifx_mode_s.lst
servername="$INFORMIXSERVER"
mode="$XX"
}   


#######################################################
# Clean up the output from sql*plus                   #
#######################################################

remove_blank_lines()
{
	sed '/rows selected/d' /tmp/ifx_mode_s.lst > /tmp/ifx_mode_s.r.lst
	sed '/^$/d' /tmp/ifx_mode_s.r.lst > /tmp/ifx_mode_s.d.lst
}

######################################################
# Remove the temp files                              #
######################################################

clean_up()
{
	rm -rf /tmp/ifx_mode_s.lst
	rm -rf /tmp/ifx_mode_s.d.lst
	rm -rf /tmp/ifx_mode_s.r.lst
}

#export debug=1 #uncomment this line for extra debugging information
export debug=0 #uncomment this line to remove extra debugging

run_sql
#remove_blank_lines 

# If debug is set, send extra information to the agent log as seen in the FOC

if [ $debug == '1' ] 
then
	echo LOG Debugging is switched on
fi

# Don't go into all the table stuffaq.if there is no data returned from the sql statement 
# otherwise the Foglight table will be full of bad data, as when no value is returned
# yet we still echo the details into an integer field, it automatically puts in a 0, which is bad

#wc -l /tmp/ifx_mode_s.d.lst | read line_count line_tmp

#if [ $line_count != '0' ]  
#then
    echo TABLE IFXMode


    # This section will have to be modified depending on the sql statement.
    # The number of variables read must equal the number of fields received from
    # the sql statement and also must equal the number of fields in the Foglight table

 #   while read servername s_mode
 #  do
	    echo START_SAMPLE_PERIOD	
	    echo serverName.String.id = $servername
	    echo mode.StringObservation.obs = $mode
	    echo END_SAMPLE_PERIOD  
 #   done < /tmp/ifx_mode_s.d.lst
    
    echo END_TABLE
#fi

#clean_up
exit 0 
